
import logging
import os
import ConfigParser

class MythosException(Exception): pass
class UnconfiguredException(MythosException): pass

_logger = None
def logger():
    global _logger
    if not _logger:
        logging.basicConfig()
        _logger = logging.getLogger(__name__)
    return _logger

def debug_trace(message):
    if logger().isEnabledFor(logging.DEBUG):
        logger().exception(message)

_handle_keys = ['driver', 'server', 'database_name', 'user_name', 'password']
class Config():
    @classmethod
    def load_config(cls):
        xpath = os.path.expanduser('~/mythos.cfg')
        try:
            config = ConfigParser.ConfigParser()
            config.read(xpath)
            values = {}
            for key in _handle_keys:
                values[key] = config.get('handle', key)
            return values
        except Exception, e:
            debug_trace("load_config")
            raise UnconfiguredException(str(e))
    
    @classmethod
    def save_config(cls, values):
        xpath = os.path.expanduser('~/mythos.cfg')
        try:
            config = ConfigParser.ConfigParser()
            config.add_section('handle')
            for key in _handle_keys:
                config.set('handle', key, values[key])
            with open(xpath, 'wb') as xfile:
                config.write(xfile)
        except Exception, e:
            debug_trace('save_config')
            raise MythosException(str(e))