from mythos import debug_trace, logger, UnconfiguredException
from mythos.command import Command, CommandException
from mythos.model import Channel
from mythos.session import new_query


class ChannelCommand(Command):
    @classmethod
    def get_help(cls):
        return '''
Help is TBD
'''

    @classmethod
    def get_name(cls):
        return 'channel'
    
    def __init__(self, unifier):
        self.unifier = unifier
    
    def execute(self, force=False):
        logger().debug("Executing channel command: " + str(self.unifier))
        try:
            if 'describe' in self.unifier.tokens:
                channel = None
                if "name" in self.unifier.variables:
                    name = self.unifier.vairables['name']
                    name = self.parameters['<name>'].binding()
                    channel = new_query(Channel, {Channel.name: name}).first()
                elif 'number' in self.unifier.variables:
                    number = self.unifier.variables['number']
                    channel = new_query(Channel, {Channel.number: number}).first()
                else:
                    raise ValueError("No channel parameter")
                Channel.show_description(channel)
            elif 'channels' in self.unifier.tokens:
                Channel.show_list(new_query(Channel).all())
            else:
                raise NotImplementedError()
        except UnconfiguredException, u:
            raise u
        except Exception, e:
            debug_trace('channel command')
            raise CommandException("Error processing channel command: " + str(self), e)
    
    def get_description_entries(self, source):
        return [
            ("Call Sign", source.call_sign),
            ("Name", source.name),
            ("Number:", source.number),
            ("Last Record Date: ", source.last_record)
        ]
    
    def get_list_entries(self):
        return [
            ("Number", self.number.rjust(3)),
            ("Name", self.name)
        ]

