from mythos import debug_trace, logger, Config
from mythos.command import Command, CommandException
from mythos.session import Session


class ConfigCommand(Command):
    @classmethod
    def get_help(cls):
        return '''
Help is TBD
'''

    @classmethod
    def get_name(cls):
        return 'config'
    
    def __init__(self, unifier):
        self.unifier = unifier
    
    def execute(self, force=False):
        logger().debug("Executing config command: " + str(self.unifier))
        try:
            if 'database' in self.unifier.tokens:
                server = None
                if "server" in self.unifier.variables:
                    server = self.unifier.variables['server'].strip("\'\"")
                else:
                    raise ValueError("No server name")
                database_name = None
                if "name" in self.unifier.variables:
                    database_name = self.unifier.variables['name'].strip("\'\"")
                else:
                    raise ValueError("No database name")
                user_name = None
                if "user" in self.unifier.variables:
                    user_name = self.unifier.variables['user'].strip("\'\"")
                else:
                    raise ValueError("No user name")
                password = None
                if "password" in self.unifier.variables:
                    password = self.unifier.variables['password'].strip("\'\"")
                else:
                    raise ValueError("No password")
                values = {
                    'driver': 'mysql+pymysql',
                    'server': server,
                    'database_name': database_name,
                    'user_name': user_name,
                    'password': password
                }
                Config.save_config(values)
                Session.handle = None
            else:
                raise NotImplementedError()
        except Exception, e:
            debug_trace('config command')
            raise CommandException("Error processing config command: " + str(self), e)
    
