from mythos import debug_trace, logger, UnconfiguredException
from mythos.command import Command, CommandException
from mythos.model import Recording
from mythos.session import new_query


class RecordingCommand(Command):
    @classmethod
    def get_help(cls):
        return '''
Help is TBD
'''

    @classmethod
    def get_name(cls):
        return 'recording'
    
    def execute(self, force=False):
        logger().debug("Executing recording command: " + str(self))
        try:
            if 'describe' in self.unifier.tokens:
                recording = None
                if 'program_id' in self.unifier.variables:
                    program_id = self.unifier.variables['program_id']
                    recording = new_query(Recording, {Recording.program_id: program_id}).first()
                else:
                    raise ValueError("No program_id parameter")
                Recording.show_description(recording)
            elif 'recordings' in self.unifier.tokens:
                joins = []
                if 'channel_number' in self.unifier.variables:
                    joins.append(Recording.channel)
                constraints = {}
                if 'delete' in self.unifier.tokens:
                    constraints[Recording.delete_pending] = 1
                Recording.show_list(new_query(Recording, joins=joins, constraints=constraints).all())
            else:
                raise NotImplementedError()
        except UnconfiguredException, u:
            raise u
        except Exception, e:
            debug_trace("channel commend")
            raise CommandException("Error processing channel command: " + str(self), e)
    
    def execute_describe(self, channel):
        channel.show_description()
        print
    
    def execute_list(self, channels):
        channels.sort(key=lambda channel: channel.number.rjust(4))
        if len(channels) == 0:
            print "No channels"
        else:
            for channel in channels:
                print channel.show_list_entry()
        print
        
