
from logging import DEBUG
import sys

from dmzb.slang.pidgin import lexer
from dmzb.slang.pidgin.recognizer import Recognizer
from dmzb.slang.pidgin.scanner import Scanner

from mythos import logger, UnconfiguredException
from mythos.command import Command, CommandException

def main(args=[]):
    if len(args) > 1 and args[1] == "-v":
        logger().setLevel(DEBUG)
        tokens = args[2:]
    else:
        tokens = args[1:]
    if len(tokens) > 0:
        process(tokens)
    else:
        shell()

def process(unifier):
    try:
        Command.dispatch(unifier)
    except CommandException, ce:
        if logger().isEnabledFor(DEBUG):
            logger().exception("Command exception")
        print 'Error handling command:', ce
        print 'For help, use the command "help".'
    except UnconfiguredException:
        print "Mythos is not configured.  Please configure with the 'config' command."
        print
    except Exception, e :
        logger().exception('Unexpected exception')
        print 'Sorry, there was a serious error handling your request:', e

def shell():
    predicates = lexer.predicates(Command.command_language)
    print 'Welcome to Mythos.  For help, type "help".'
    print
    while True:
        try:
            line = raw_input('Mythos: ')
            unifier = Recognizer.recognize(predicates, Scanner.scan(line))
            if unifier:
                process(unifier)
            else:
                print "Sorry, couldn't parse '%s'" % line
        except EOFError:
            break
    print 'Have a nice day!'       

if __name__ == "__main__":
    main(sys.argv)
